//
//  lariat-online/include/TriggerPattern.h    (W.Badgett)
//
//  Description of one LArIAT trigger, clock time, input bits 
//  trigger counter and trigger pattern number one for each trigger 
//  generated by the V1495 board
//

#include <iostream>

#ifndef _TriggerPattern_h
#define _TriggerPattern_h

class TriggerPattern
{
 public:

#pragma pack(push,1)

  typedef struct TriggerPattern_t
  {
    uint32_t timeStamp;
    uint32_t inputPattern;
  } TriggerPattern_t;

#pragma pack(pop)

  TriggerPattern();

  TriggerPattern_t triggerPattern;

  uint32_t streamToBuffer(std::ostream& buffer);
  uint32_t fillFromBuffer(std::istream& buffer);

  static void printTriggerPattern(TriggerPattern_t pattern, 
  				  std::ostream& os = std::cout);
};

std::ostream& operator<<(std::ostream& os, const TriggerPattern& e);
std::ostream& operator<<(std::ostream& os, 
			 const TriggerPattern::TriggerPattern_t& e);

#endif
